Subject: Re: Find the next tag on a given branch

From: Artur Skawina <[email-masked]>
Date: Thu, 09 Sep 2010 18:12:28 +0200

On 09/09/10 07:28, martin f krafft wrote:
> I want to find the next tag (the tag following a commit), but
> require that it lie on a given branch. Alternatively, a filter

> The way Debian packages are (mostly) maintained in Git is that
> there are at least an upstream and a Debian branch (usually
> "master"). master branched off upstream, and upstream is merged into
> master at regular intervals. Whenever a Debian release is made, the
> corresponding branch is tagged.
> 
> If I run
> 
>   git describe --contains mycommitish
> 
> it prints the next tag, which is usually upstream's tag, which is
> not quite what I want (it's usually enough for me to figure it out,
> but this is Git and so I should be able to do even better! ;\) )
> 
> I would like to have it continue the search until it reaches the
> master branch. For instance, a command like
> 
>   git describe --contains mycommit --on-branch master

It's not that simple, as 'mycommit', once merged, /is/ technically part
of master.

If 'upstream' contains just imports, ie has no merges whatsoever, like
eg git://git.debian.org/collab-maint/batmand.git, you could use something
like this: 

$ git rev-list --ancestry-path --merges mycommit..master | xargs -n1 git describe --contains

(this doesn't catch the very first initial import (and release tag),
 but that case isn't very interesting anyway)

With a more complicated history, with many merges, you'd have to
do something more like

1) git rev-list --ancestry-path --merges mycommit..master
2) filter out all the merge ids from this list that are reachable from
   'upstream'
3) git describe --contains 

Easily scriptable, but i don't see a way to express the 2nd step
in pure git-speak right now. [1] Is there a way?

Or you could just extend 'git describe --contains' to take another
optional ref, check if the object pointed to by the tag that it finds
is reachable from that ref, and skip this tag if yes.
Then you could do `git describe --contains mycommit --skip upstream`. ;)

artur

[1] iff i got it right. Consider history such as:
               
         ...-> c
                \    
upstream -> C -> m -> c ----> ... ---> c ---> upstream
                       \                \
master   -------------> M -> m -> ... -> m -> master
                            /
         ... ------------> c

Asking for a released 'C' must result in 'M'. 
(Merging 'master' into 'upstream' must not happen, obviously)